import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AppInstallationRepositoriesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/app_installation_repositories#id AppInstallationRepositories#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/app_installation_repositories#installation_id AppInstallationRepositories#installation_id}
    */
    readonly installationId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/app_installation_repositories#selected_repositories AppInstallationRepositories#selected_repositories}
    */
    readonly selectedRepositories: string[];
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/github/r/app_installation_repositories github_app_installation_repositories}
*/
export declare class AppInstallationRepositories extends cdktf.TerraformResource {
    static readonly tfResourceType = "github_app_installation_repositories";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/github/r/app_installation_repositories github_app_installation_repositories} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AppInstallationRepositoriesConfig
    */
    constructor(scope: Construct, id: string, config: AppInstallationRepositoriesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _installationId?;
    get installationId(): string;
    set installationId(value: string);
    get installationIdInput(): string | undefined;
    private _selectedRepositories?;
    get selectedRepositories(): string[];
    set selectedRepositories(value: string[]);
    get selectedRepositoriesInput(): string[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
