import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataGithubRepositoryTeamsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/d/repository_teams#full_name DataGithubRepositoryTeams#full_name}
    */
    readonly fullName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/d/repository_teams#id DataGithubRepositoryTeams#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/d/repository_teams#name DataGithubRepositoryTeams#name}
    */
    readonly name?: string;
}
export interface DataGithubRepositoryTeamsTeams {
}
export declare function dataGithubRepositoryTeamsTeamsToTerraform(struct?: DataGithubRepositoryTeamsTeams): any;
export declare class DataGithubRepositoryTeamsTeamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataGithubRepositoryTeamsTeams | undefined;
    set internalValue(value: DataGithubRepositoryTeamsTeams | undefined);
    get name(): string;
    get permission(): string;
    get slug(): string;
}
export declare class DataGithubRepositoryTeamsTeamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataGithubRepositoryTeamsTeamsOutputReference;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/github/d/repository_teams github_repository_teams}
*/
export declare class DataGithubRepositoryTeams extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "github_repository_teams";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/github/d/repository_teams github_repository_teams} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataGithubRepositoryTeamsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataGithubRepositoryTeamsConfig);
    private _fullName?;
    get fullName(): string;
    set fullName(value: string);
    resetFullName(): void;
    get fullNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _teams;
    get teams(): DataGithubRepositoryTeamsTeamsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
