import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ReleaseConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#body Release#body}
    */
    readonly body?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#discussion_category_name Release#discussion_category_name}
    */
    readonly discussionCategoryName?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#draft Release#draft}
    */
    readonly draft?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#generate_release_notes Release#generate_release_notes}
    */
    readonly generateReleaseNotes?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#id Release#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#name Release#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#prerelease Release#prerelease}
    */
    readonly prerelease?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#repository Release#repository}
    */
    readonly repository: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#tag_name Release#tag_name}
    */
    readonly tagName: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/github/r/release#target_commitish Release#target_commitish}
    */
    readonly targetCommitish?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/github/r/release github_release}
*/
export declare class Release extends cdktf.TerraformResource {
    static readonly tfResourceType = "github_release";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/github/r/release github_release} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ReleaseConfig
    */
    constructor(scope: Construct, id: string, config: ReleaseConfig);
    private _body?;
    get body(): string;
    set body(value: string);
    resetBody(): void;
    get bodyInput(): string | undefined;
    private _discussionCategoryName?;
    get discussionCategoryName(): string;
    set discussionCategoryName(value: string);
    resetDiscussionCategoryName(): void;
    get discussionCategoryNameInput(): string | undefined;
    private _draft?;
    get draft(): boolean | cdktf.IResolvable;
    set draft(value: boolean | cdktf.IResolvable);
    resetDraft(): void;
    get draftInput(): boolean | cdktf.IResolvable | undefined;
    get etag(): string;
    private _generateReleaseNotes?;
    get generateReleaseNotes(): boolean | cdktf.IResolvable;
    set generateReleaseNotes(value: boolean | cdktf.IResolvable);
    resetGenerateReleaseNotes(): void;
    get generateReleaseNotesInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _prerelease?;
    get prerelease(): boolean | cdktf.IResolvable;
    set prerelease(value: boolean | cdktf.IResolvable);
    resetPrerelease(): void;
    get prereleaseInput(): boolean | cdktf.IResolvable | undefined;
    private _repository?;
    get repository(): string;
    set repository(value: string);
    get repositoryInput(): string | undefined;
    private _tagName?;
    get tagName(): string;
    set tagName(value: string);
    get tagNameInput(): string | undefined;
    private _targetCommitish?;
    get targetCommitish(): string;
    set targetCommitish(value: string);
    resetTargetCommitish(): void;
    get targetCommitishInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
